# import necessary libraries
import glob
import pandas as pd
import os
import argparse
import numpy as np
from sklearn.preprocessing import MinMaxScaler
from sklearn.preprocessing import KBinsDiscretizer

ap = argparse.ArgumentParser()
ap.add_argument("-f", "--files", required=True, help="Directory of Files")
args = vars(ap.parse_args())


def getlstfiles(location):
    files = glob.glob(location)
    return files


# normalize the data using sklearn transform, if the transform is too slow it can be switched to a manual normalization
# column by column via apply
def normalize(frame):
    # make a dataframe for normalizing by row and by columns
    df_col = df
    df_row = df.T
    scaler = MinMaxScaler()
    # normalize by column inplace
    scaled_values_col = scaler.fit_transform(df_col.iloc[2:, 1:])
    df_col.iloc[2:, 1:] = scaled_values_col
    # normalize by row in place
    scaled_values_row = scaler.fit_transform(df_row.iloc[1:, 2:])
    df_row.iloc[1:, 2:] = scaled_values_row
    return (df_row, df_col)


# bins the data using 3 bins and equal widths automatically calculated during fit
def bin(n_col, n_row):
    enc = KBinsDiscretizer(n_bins=3, encode='ordinal')
    col_binned = enc.fit_transform(df_col.iloc[2:, :])
    df_col.iloc[2:, :] = col_binned

    row_binned = enc.fit_transform(df_row.iloc[:, 2:])
    df_row.iloc[:, 2:] = row_binned
    df_row_bin = df_row
    df_col_bin = df_col
    return (df_row_bin, df_col_bin)

#def counter():

#def '///' feature remover()

# processes the files, can definitely be partially functioned / cleaned up in future
lstfiles = getlstfiles(args['files'])
for f in lstfiles:
    df = pd.read_csv(f, index_col=0)
    filename = os.path.split(f)[1]
    df.rename(columns={'Unnamed: 0': 'Gene'}, inplace=True)

    # normalize the data
    df_row, df_col = normalize(f)
    rowname = str('/home/user/Desktop/Lab_SMLG/test_smlg/row_normal_' + filename)
    colname = str('/home/user/Desktop/Lab_SMLG/test_smlg/col_normal_' + filename)
    df_row_T = df_row.T
    df_row_T.to_csv(rowname, index=1)
    df_col.to_csv(colname, index=1)

    # bin the normalized data

    df_row_bin, df_col_bin = bin(df_row, df_col)
    df_row_bin_T = df_row_bin.T
    bin_row_name = str('/home/user/Desktop/Lab_SMLG/test_smlg/bin_row_' + filename)
    bin_col_name = str('/home/user/Desktop/Lab_SMLG/test_smlg/bin_col_' + filename)
    df_row_bin_T.to_csv(bin_row_name, index=1)
    df_col_bin.to_csv(bin_col_name, index=1)
